###############################################################################
# BizDesign ImageFolio Lite Edition 4.2 (Four-dot-Two)
###############################################################################
#
#          ##          ###        VERSION       :  4.2
#        ####        ##   ##      RELEASED ON   :  02/15/2007
#      ##  ##              ##     LAST MODIFIED :  02/15/2007
#    ##########          ##       
#          ##   ###    ##         
#          ##   ###  ########     
#
###############################################################################
# Released by BizDesign, Inc.
# written by Dirk Koppers and Greg Raaum of BizDesign
#
# Purchasing :  http://imagefolio.com/purchase/
# Support    :  http://imagefolio.com/support/
# Phone      :  (214) 642-9787
# Email      :  sales@bizdesign.com
###############################################################################
# COPYRIGHT AND LICENSE INFORMATION :
#
# Copyright (c) 1999-2007 BizDesign, Inc. All rights reserved.
#
# Selling or distributing the code for this program without prior written
# consent is expressly forbidden.
#
# One licensed copy of the program may reside on a single server, in use by a
# single domain.  For each installed instance of the program, a separate
# license is required.
#
# Licensed users may alter or modify this software, at their own risk, of
# course.  They may also hire others to modify their own copy of the code, as
# long as the code is not transferred to or retained by the individual who is
# hired (unless he/she is also a license holder). Although license-holders
# may modify the code for their use, modified code may NOT be resold or
# distributed.
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL BIZDESIGN,
# INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# BizDesign, Inc. is not liable for any conduct associated with image gallery
# activity, nor for any binary media posted using this program, including but
# not imited to images, photographs, movies, and clipart.
#
# The user must assume the entire risk of using the program.  Although this
# program has been thoroughly tested on BizDesign's servers, BizDesign does not
# warrant that it works on all servers and will not be held liable for anything,
# including but not limited to, misusage, error, or loss of data.  ANY
# LIABILITY OF THE SELLER WILL BE LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT
# OR REFUND OF PURCHASE PRICE.  Use at your own risk!
###############################################################################
# Do not modify below this line unless you know what you are doing.
###############################################################################
use HTML::Entities;

# 1 font
# 2 color

my %configs = (
	     aa => ['cat_font',					'WHAT FONT, AND SIZE WOULD YOUR LIKE TO USE TO DISPLAY THE CATEGORIES AND SUBCATEGORIES?', 'The columned category list is the default or main page - category names are determined by your directory names! Note: the color of the font is set in the home.html and thumbnails.html template. Look for &lt;style type="text/css"&gt;', 1],
	     ab => ['main_header_font',			'WHAT FONT, COLOR, AND SIZE WOULD YOUR LIKE TO USE TO DISPLAY HEADER TEXT?', 'The columned subcategory list is the default or main page - category names are determined by your directory names. Backslash quote signs!', 1],
	     ac => [['main_table_border_color', 'main_header_bgcolor', 'main_nav_bgcolor'],
											'WHAT COLORS DO YOU WANT TO USE FOR THE MAIN TABLE?', '', [2, 2, 2]],
	     ad => ['table_background_color',	'WHAT BACKGROUND COLOR WOULD YOU LIKE TO USE FOR THUMBNAIL INFORMATION?', 'This is the table that displays image information', 2],
	     ae => ['font',						'WHAT FONT, COLOR, AND SIZE WOULD YOUR LIKE TO USE TO DISPLAY IMAGE INFORMATION AND PAGE LOCATION?', 'The columned subcategory list is the default or main page - category names are determined by your directory names. Backslash quote signs!', 1],
	     af => ['thumb_table_bgcolor',		'WHAT BACKGROUND COLOR DO YOU WANT THE TABLE TO BE ON THUMBNAIL PAGES?', '', 2],
	     ag => ['thumb_table_border_color',	'WHAT BORDER COLOR DO YOU WANT SURROUND THE IMAGES AND IMAGE INFO?', '', 2],
	     ah => ['subcat_bgcolor',			'WHAT TABLE BACKGROUND COLOR DO YOU WANT TO USE FOR DISPLAYING YOUR SUBCATEGORIES?', '', 2],
	     ai => ['count_font',				'WHAT FONT TYPE, COLOR, AND SIZE WOULD YOU LIKE TO USE TO DISPLAY IMAGE COUNTS?', '', 1],
	     aj => [['fe_admin_font', 'fe_admin_small_font'],
											'WHAT FONT TYPE, COLOR, AND SIZE WOULD YOU LIKE TO USE TO DISPLAY IMAGE COUNTS?', '', [1, 1]],
	     ak => [['body_bgcolor', 'radio_bgcolor'],
	     									'WHAT BACKGROUND COLOR ARE YOUR PAGES SET TO?', 'This is for both the page background color and the color behind the radio buttons. Radio buttons don\'t show up well against colored backgrounds on certain browsers. It displays a little white square instead.', [2, 2]],
	     al => ['use_textlinks',			'DO YOU WANT TO STICK WITH GRAPHICAL BUTTONS OR USE TEXT LINKS LIKE THE BONES SKIN DOES?', 'Set this to "yes" if you want text only and no buttons or graphics. Note, if you set this you should increase page width.', 0],
	     am => [['font_add_link', 'font_remove_link'],
	     									'IF YOU ARE USING TEXTLINKS ABOVE, WHAT COLORS DO YOU WANT THE ADD TO LIGHTBOX AND REMOVE FROM LIGHTBOX TO BE?', 'If you choose to use texlinks then you can also specify the font (type, color, size) for the "Add" and "Remove" links.', [1, 1]],
	     an => ['font_dl_link',				'WHAT TYPE STYLE DO YOU WANT TO USE FOR THE DOWNLOAD LINK, IF USING TEXTLINKS', 'This appears underneath the thumbnail and preview if a full-size download is granted to the user.  Define the font below.', 1],
	     ao => ['admin_button_wh',			'ADMIN BUTTON WIDTH HEIGHT', '', 1],
); 

my $error_display;



sub admin_button_wh_write {
	my $section = $FORM{'section'};
	
	if ($configs{$section}->[0] eq 'admin_button_wh') {
		$admin_button_wh = '';
	
		my $width = $FORM{'width'} + 0;
		my $height = $FORM{'height'} + 0;
		
		$admin_button_wh .=	' width="' . $width . '"' if $width;
		$admin_button_wh .=	' height="' . $height . '"' if $height;
	}

	my $write = '$admin_button_wh = \'' . $admin_button_wh .  '\';' . "\n";
		
	return($write);
}


sub admin_button_wh_edit {
	my $width_height = $admin_button_wh;
	
	my $width = $height = '';
		
	if ($width_height) {
		$width_height =~ s/"//ig;
		$width_height =~ s/^\s+//ig;
		$width_height =~ s/\s+$//ig;
				
		my @elements = split(/\s+/, $width_height);
				
		foreach my $element(@elements) {
			my ($name, $value) = split('=', $element);
					
			$width = $value if $name eq 'width';
			$height = $value if $name eq 'height';
		}
		
	}

	my $display .= qq{
  <table border=0 cellspacing=1 cellpadding=5 width="400" bgcolor="#000000" align="center">
	<tr>
	  <td bgcolor="#dddddd" align=center>
	    <font face="Verdana,Arial,Helvetica" size="1"><b>skin_name</b></font></td>
	  </td>
	  <td bgcolor="#ffffff" align=center valign=top>
	    <font face="Verdana,Arial,Helvetica" size="1">Width: <input type="text" name="width" value="$width" size="4"> &nbsp; &nbsp; Height: <input type="text" name="height" value="$height" size="4">
	  </td>
	</tr>
  </table>
  	};
	
	return($display);		
}

sub description {
	my $skin = shift;
	
	my $skins_dir = $base_skin_dir;
	
	my $skin_dir = "$skins_dir/$skin";

	my $description_file = $skin_dir . '/description.txt';
	
	my $description_in = $FORM{'description'};
	my $update = $FORM{'update'};


	if ($description_in && $update) {
      unless ($admin_demo_mode) {
         open(DESC, ">$description_file");
         print DESC $description_in;
         close(DESC);
      }
      return;
	}

	my $description = '';

	if (-e $description_file) {
		open(DESC, $description_file); 
		my @description = <DESC>;
		close(DESC);

		$description = join(' ', @description);

		chomp($description);

		$description =~ s/\s+/ /g;
		
		$description = encode_entities($description);
	}
	
	&get_header;

	print qq{
<center>
<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000">
  <tr>
    <td>
      <table border="0" width="100%" cellspacing=1 cellpadding=0>
        <tr bgcolor="#ffcc00">
          <td>
            <table border="0" width="100%" cellspacing=0 cellpadding=4>
              <tr>
                <td><$admin_big_font><b>ImageFolio Skins Manager</b></font></td>
                <td align=right><$admin_big_font><b>Edit Description</b></font></td>
              </tr>
            </table>
          </td>
        </tr>
        <tr bgcolor="#ffffff">
          <td valign=top>
            <table border=0 cellspacing=1 cellpadding=15 width="100%">
  <tr bgcolor="#eeeeee">
    <td bgcolor="#eeeeee" align=center>
      <$admin_font><b>$skin</b></font>
    </td>
  </tr>
              <tr bgcolor="#eeeeee">
                <form method="post" action="$adminurl#description">
                <input type="hidden" name="admin" value="admin">
                <input type="hidden" name="cgi" value="skins.pl">
                <input type="hidden" name="edit" value="yes">
                <input type="hidden" name="skin" value="$skin">
                <input type="hidden" name="section" value="description">
                <input type="hidden" name="uid" value="$FORM{'uid'}">
                <td bgcolor="#eeeeee" align="center">
                <textarea name=description rows="7" cols="60" >$description</textarea><br>
                <input type="submit" name="update" value="Update Description"><input type="submit" name="cancel" value="Cancel">
                </form>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
	};

	&get_footer;
	
	exit;
}

sub images {
	my $skin = shift;
	
	my $skins_dir = $base_skin_dir;
	
	my $skin_dir = "$skins_dir/$skin";

	my $image = $FORM{'image'};

	my $image_dir = "$skin_dir/images";
	
	opendir(IMAGES, $image_dir);
	my @images = readdir IMAGES;
	closedir(IMAGES);
	
	@images = sort(@images);
	
	my $files = '';
	
	foreach my $file(@images) {
		next if $file !~ /\.[png|gif|jpg]/i;
	
		my $selected = $file eq $image ? ' selected' : '';
			
		$files .= qq{<option value="$file"$selected>$file</option>};
	}
	
	$files .= qq{<option value=""> - Media Icons - </option>};

	my $icons_dir = "$image_dir/icons";
	
	opendir(ICONS, $icons_dir);
	my @icons = readdir ICONS;
	closedir(ICONS);
	
	@icons = sort(@icons);
	
	foreach my $file(@icons) {
		next if $file !~ /\.[png|gif|jpg]/i;
	
		my $selected = "icons/$file" eq $image ? ' selected' : '';
	
		$files .= qq{<option value="icons/$file"$selected>$file</option>};
	}
	
	my $editor = qq{
<form method="post" action="$adminurl">
<input type="hidden" name="admin" value="admin">
<input type="hidden" name="cgi" value="skins.pl">
<input type="hidden" name="edit" value="yes">
<input type="hidden" name="skin" value="$skin">
<input type="hidden" name="section" value="images">
<input type="hidden" name="uid" value="$FORM{'uid'}">
<select name="image" onChange="this.form.submit()">
<option value=""> - Select an Image - </option>
$files
</select>
</form>
<br>
	};
	
	if ($image) {
		my $image_file = "$image_dir/$image";
		
		if (-e $image_file) {
			my $notice = '';
			my $new_image_file = $FORM{'upload'};
		
			if ($new_image_file) {
				my $temp_image = "$tempuploaddir/$new_image_file";
					
				if ($image_file =~ /\.png$/i) {
					$notice = 'Uploaded file must be same file type: .png' if $temp_image !~ /\.png$/i;
				} elsif ($image_file =~ /\.gif$/i) {
					$notice = 'Uploaded file must be same file type: .gif' if $temp_image !~ /\.gif$/i;
				} elsif ($image_file =~ /\.jpg$/i) {
					$notice = 'Uploaded file must be same file type: .jpg' if $temp_image !~ /\.jpg$/i;
				}
			
				if (!$notice) {
					rename($temp_image, $image_file) or $notice = $!;
				}
				
				unlink($temp_image);
			}
			
			my $random = time;
					
			$editor .= qq{
<$admin_font><font color=red>$notice</font></font><br>
<img src="$base_skin_url/$skin/images/$image?random=$random" border=0>
<br><br>
<form name="skin_image_upload" method="post" action="$uploadurl" enctype="multipart/form-data">
<input type="hidden" name="admin" value="admin">
<input type="hidden" name="cgi" value="skins.pl">
<input type="hidden" name="edit" value="yes">
<input type="hidden" name="skin" value="$skin">
<input type="hidden" name="section" value="images">
<input type="hidden" name="uid" value="$FORM{'uid'}">
<input type="hidden" name="category" value="1">
<input type="hidden" name="admin_skin_image" value="1">
<input type="hidden" name="image" value="$image">
<input type="file" name="skin_upload"><input type="submit" value="Replace Image">
</form>
			};			
		}
	}
	
	&get_header;

	print qq{
<center>
<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000">
  <tr>
    <td>
      <table border="0" width="100%" cellspacing=1 cellpadding=0>
        <tr bgcolor="#ffcc00">
          <td>
            <table border="0" width="100%" cellspacing=0 cellpadding=4>
              <tr>
                <td><$admin_big_font><b>ImageFolio Skins Manager</b></font></td>
                <td align=right><$admin_big_font><b>Skin Images</b></font></td>
              </tr>
            </table>
          </td>
        </tr>
        <tr bgcolor="#ffffff">
          <td valign=top>
            <table border=0 cellspacing=1 cellpadding=15 width="100%">
  <tr bgcolor="#eeeeee">
    <td bgcolor="#eeeeee" align=center>
      <$admin_font><b>$skin</b></font>
    </td>
  </tr>
              <tr bgcolor="#eeeeee">
                <td bgcolor="#eeeeee" align="center">
                  $editor
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
	};

	&get_footer;
	
	exit;
}


sub update {
	my $skin = shift;

	my $section = $FORM{'section'};

	return if !$configs{$section};

	&get_header;

	print &picker;

	print qq{
<center>
<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000">
  <tr>
    <td>
      <table border="0" width="100%" cellspacing=1 cellpadding=0>
        <tr bgcolor="#ffcc00">
          <td>
            <table border="0" width="100%" cellspacing=0 cellpadding=4>
              <tr>
                <td><$admin_big_font><b>ImageFolio Skins Manager</b></font></td>
                <td align=right><$admin_big_font><b>Edit</b></font></td>
              </tr>
            </table>
          </td>
        </tr>
        <tr bgcolor="#ffffff">
          <td valign=top>
            <table border=0 cellspacing=1 cellpadding=5 width="100%">
  <tr bgcolor="#eeeeee">
    <td bgcolor="#eeeeee" align=center>
      <$admin_font><b>$skin</b></font>
    </td>
  </tr>
	};
	
	my $config = $configs{$section};
		
	my ($params, $question, $info, $field_types) = @{$config};
		
	my $type = ref($params);
		
	$type = 'sub' if defined(&{$params . '_edit'});
		
	$params = [$params] if !$type;
	
	$field_types = [$field_types] if !$type;
				
	my $section = qq{
              <tr bgcolor="#eeeeee">
                <td bgcolor="#eeeeee" align=left>
                  <$admin_font><b>$question</b></font><br>
                  <$admin_font>$info<br></font><br>
                  <center><$admin_font color=red>$error_display</font></center>
                  <form name="updateForm" method="post" action="$adminurl#$section">
                  <input type="hidden" name="admin" value="admin">
                  <input type="hidden" name="cgi" value="skins.pl">
                  <input type="hidden" name="edit" value="yes">
                  <input type="hidden" name="skin" value="$skin">
                  <input type="hidden" name="section" value="$section">
                  <input type="hidden" name="uid" value="$FORM{'uid'}">
 	};
		
	if ($type eq 'sub') {
		$section .= &{$params . '_edit'};
	} else {
		$section .= qq{<table border=0 cellspacing=1 cellpadding=5 width="500" bgcolor="#000000" align="center">};
		
		my $field = 0;

		foreach my $param(@{$params}) {
			my $value = eval('$' . $param);
			
			my $field_type = $field_types->[$field];
			
			my $input = '';
			
#			my $input = qq{<input type="text" name="$param" value="$value" size=30>};
#			
			if ($field_type == 0) {
				my $yes_checked = $value ? ' checked' : '';
				
				my $no_checked = $value ? '' : ' checked';
				
				$input = qq{<input type="radio" name="$param" value="1"$yes_checked>yes &nbsp; &nbsp; <input type="radio" name="$param" value="0"$no_checked>no};
			}

			if ($field_type == 1) {
				my $font = $value;
				
				$font =~ s/^font//ig;
				$font =~ s/"//ig;
				$font =~ s/,\s+/,/ig;
				$font =~ s/\s+,/,/ig;
				$font =~ s/^\s+//ig;
				$font =~ s/\s+$//ig;
				
				my $face = $color = $size = '';
				
				my @elements = split(/\s+/, $font);
				
				foreach my $element(@elements) {
					my ($name, $value) = split('=', $element);
					
					$face = $value if $name eq 'face';
					$color = $value if $name eq 'color';
					$size = $value if $name eq 'size';
				}
				
#				$color =~ s/^#//ig;
				$color = uc($color);
				
				my $plus = $size =~ /^\+/ ? ' selected' : '';
				my $minus = $size =~ /^\-/ ? ' selected' : '';
				
				$size =~ s/\D//;
				
				$input = qq{
				  <b>face</b><br><input type="text" name="$param\_face" value="$face" size="15"><p>
				  <b>color</b><br><input type="text" name="$param\_color" value="$color" size="7"><A HREF="#" onClick="cp.select(document.updateForm.$param\_color,'pick');return false;" NAME="pick" ID="pick">Choose Color</A><p>
				  <b>size</b><br><select name="$param\_operator"><option value=""></option><option value="plus"$plus>+</option><option value="minus"$minus>-</option></select>
				  <input type="text" name="$param\_size" value="$size" size="5">
				};
			}
			
			if ($field_type == 2) {
				my $color = $value;
#				$color =~ s/^#//ig;
				$color = uc($color);
				$input = qq{<input type="text" name="$param" value="$color" size="7"><A HREF="#" onClick="cp.select(document.updateForm.$param,'pick');return false;" NAME="pick" ID="pick">Choose Color</A>};
			}
					
			$section .= qq{
	                 <tr> 
	                   <td bgcolor="#dddddd" align=center width="50%"><font face="Verdana,Arial,Helvetica" size="1"><b>$param</b></font></td>
	                   <td bgcolor="#ffffff" align=center valign=top><font face="Verdana,Arial,Helvetica" size="1">$input</font></td>
	                 </tr>
			};
			
			$field++;
		}
			
		$section .= qq{</table>};
	}
		
	$section .= qq{<br><center><input type="submit" name="update" value="Update Configuration"> &nbsp; <input type="submit" name="cancel" value="Cancel"></form></center>
	                </td>
	              </tr>
	};

	print $section;
             
	print qq{
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
	};

	&get_footer;

	exit;
}

sub write {
	my $skin = shift;

	my $section = $FORM{'section'};
	
	return if !$configs{$section};
	
	my $write = '';
	
	foreach my $key(sort(keys(%configs))) {
		my $config = $configs{$key};
		
		my ($params, $question, $info, $field_types) = @{$config};
		
		my $type = ref($params);
		
		$type = 'sub' if defined(&{$params . '_write'});
		
		$params = [$params] if !$type;
		
		$field_types = [$field_types] if !$type;
		
		if ($type eq 'sub') {
			$write .= &{$params . '_write'};
			
			return if $error_display;
		} else {
			my $field = 0;
		
			foreach my $param(@{$params}) {
				my $value = eval('$' . $param);
				
				my $field_type = $field_types->[$field];
				
				if ($key eq $section) {
					my $new_value = '';
					
						if ($field_type == 0) {
							$new_value = $FORM{$param} + 0; # force value to a number
							$new_value = $new_value ? 1 : 0; # if it's a boolean, go ahead and make it a one or zero
						}
				
					if ($field_type == 1) {
						$new_value .= 'font ' if $value =~ /^font/i;
						
						my $face = $FORM{$param . '_face'};
						if ($face) {
							$face =~ s/\s//ig;
							
							my @faces = split(',', $face);
							
							my $new_face = '';
							
							foreach my $font(@faces) {
								$font =~ s/\W+//;
								
								if ($font) {
									$new_face .= "$font,";
								}
							}
							
							chop($new_face);
							
							if ($new_face) {
								$new_value .= 'face="' . $new_face . '" ';
							}
						}
						
						my $color = $FORM{$param . '_color'};
						if ($color) {
							$color =~ s/^\#//ig;
						
							if ($color =~ /^[a-fA-F0-9][a-fA-F0-9][a-fA-F0-9][a-fA-F0-9][a-fA-F0-9][a-fA-F0-9]$/) {
								$new_value .= 'color="#' . uc($color) . '" ';
							} else {
								$new_value .= 'color="#' . $color . '" ';
								
								$error_display = 'Colors must be a hex value.';
							}
						}
						
						my $size = $FORM{$param . '_size'} + 0;
						if ($size) {
							my $operator_in = $FORM{$param . '_operator'};

							my $operator = '';
							
							$operator = '+' if $operator_in eq 'plus';
							$operator = '-' if $operator_in eq 'minus';
							
							$new_value .= 'size="' . $operator . $size . '" ';
						}
						
						chop($new_value);
					}
					
					if ($field_type == 2) {
						my $color = $FORM{$param};
						if ($color) {
							$color =~ s/^\#//ig;
						
							if ($color =~ /^[a-fA-F0-9][a-fA-F0-9][a-fA-F0-9][a-fA-F0-9][a-fA-F0-9][a-fA-F0-9]$/) {
								$new_value = '#' . uc($color);
							} else {
								$new_value = $color;
								
								$error_display = 'Colors must be a hex value.';
							}
						} else {
							$new_value = '';
						
							$error_display = 'You must supply a hex color.';
						}
					}
																				
					eval('$' . $param . '=' . "'" . $new_value . "'");
					
					return if $error_display;
					
					$value = $new_value;
				}
				
				$write .= "\$$param = '$value';\n";
				
				$field++;
			} 
		}
	}
	
	my $skins_dir = $base_skin_dir;
	
	my $config_file = "$skins_dir/$skin/skin_edit.pl";
	
   unless ($admin_demo_mode) {
      open(CONFIG, ">$config_file");
      flock(CONFIG, 2) if $useflock;
      print CONFIG "$write\n1;";
      flock(CONFIG, 8) if $useflock;
      close(CONIG);
      chmod(0777, "$config_file");
   }
}	

	
sub edit {
	my $skin = shift;
	
	my $skins_dir = $base_skin_dir;
	
	my $skin_dir = "$skins_dir/$skin";

	return if !-e "$skin_dir/config_skin.pl";
	
	require "$skin_dir/config_skin.pl";
	eval{require "$skin_dir/skin_edit.pl";};
	
	my $section = $FORM{'section'};
	my $cancel = $FORM{'cancel'};
	
	&images($skin) if $section eq 'images';
	&description($skin) if $section eq 'description' && !$cancel;
	
	my $error = &write($skin) if $FORM{'section'} && $FORM{'update'};

	&update($skin) if $FORM{'section'} && ($FORM{'edit'} eq 'update' || $error_display);
		
	&get_header;

	print qq{
<center>
<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000">
  <tr>
    <td>
      <table border="0" width="100%" cellspacing=1 cellpadding=0>
        <tr bgcolor="#ffcc00">
          <td>
            <table border="0" width="100%" cellspacing=0 cellpadding=4>
              <tr>
                <td><$admin_big_font><b>ImageFolio Skins Manager</b></font></td>
                <td align=right><$admin_big_font><b>Edit</b></font></td>
              </tr>
            </table>
          </td>
        </tr>
        <tr bgcolor="#ffffff">
          <td valign=top>
            <table border=0 cellspacing=1 cellpadding=15 width="100%">
	};
	
	my $description_file = $skin_dir . '/description.txt';

	my $description = '';

	if (-e $description_file) {
		open(DESC, $description_file); 
		my @description = <DESC>;
		close(DESC);

		$description = join(' ', @description);

		chomp($description);

		$description =~ s/\s+/ /g;
	}

	print qq{
  <tr bgcolor="#eeeeee">
    <td bgcolor="#eeeeee" align=center>
      <$admin_font><b>$skin</b></font>
    </td>
  </tr>
  <tr bgcolor="#eeeeee">
    <td bgcolor="#eeeeee">
      <table border=0 cellspacing=0 cellpadding=0 width="100%">
        <tr>
          <td align=left>
            <$admin_font><A HREF="$adminurl&cgi=skins.pl&edit=yes&skin=$skin&section=description&uid=$FORM{'uid'}" class="roll2"><b>Description</b><img src="$skin_url/images/edit.gif" align=right border=0 vspace=3 hspace=3></a></font><br>
            <$admin_font>$description</font>
          </td>
        </tr>
      </table>
    </td>
  </tr>
  <tr bgcolor="#eeeeee">
    <td bgcolor="#eeeeee">
      <table border=0 cellspacing=0 cellpadding=0 width="100%">
        <tr>
          <td align=left>
            <$admin_font><A HREF="$adminurl&cgi=templates.pl&skin=$skin&uid=$FORM{'uid'}" class="roll2"><b>Template Editor</b><img src="$skin_url/images/edit.gif" align=right border=0 vspace=3 hspace=3></a></font><br>
            <$admin_font>ImageFolio's templates are simple HTML files. Feel free to edit these files to your liking but please note that each file contains special tags like this:<p><center>%%%IMAGEFOLIO_TAG_NAME%%%<p><font color=red>These tags must be kept intact for ImageFolio to work properly.</font>
          </td>
        </tr>
      </table>
    </td>
  </tr>
  <tr bgcolor="#eeeeee">
    <td bgcolor="#eeeeee">
      <table border=0 cellspacing=0 cellpadding=0 width="100%">
        <tr>
          <td align=left>
            <$admin_font><A HREF="$adminurl&cgi=skins.pl&edit=yes&skin=$skin&section=images&uid=$FORM{'uid'}" class="roll2"><b>Skin Images</b><img src="$skin_url/images/edit.gif" align=right border=0 vspace=3 hspace=3></a></font><br>
            <$admin_font>Upload new images for this skin.</font>
          </td>
        </tr>
      </table>
    </td>
  </tr>
  	};
  
	foreach my $key(sort(keys(%configs))) {
		my $config = $configs{$key};
		
		my ($params, $question, $info, $field_types) = @{$config};
		
		my $type = ref($params);
		
		$type = 'sub' if defined(&{$params . '_menu'});
		
		$params = [$params] if !$type;
		
		$field_types = [$field_types] if !$type;
				
		my $section = qq{
              <tr bgcolor="#eeeeee">
                <td bgcolor="#eeeeee"><table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align=left>
    		      <a name="$key">
                  <$admin_font><A HREF="$adminurl&cgi=skins.pl&section=$key&edit=update&skin=$skin&uid=$FORM{'uid'}" class="roll2"><b>$question</b><img src="$skin_url/images/edit.gif" align=right border=0 vspace=3 hspace=3></a></font><br>
                  <$admin_font>$info</font></td></tr><tr><td align=center>
 		};
		
		if ($type eq 'sub') {
			$section .= &{$params . '_menu'};
		} else {
			$section .= qq{<br><table border=0 cellspacing=1 cellpadding=2 width="400" bgcolor="#000000">};
			
			my $field = 0;

			foreach my $param(@{$params}) {
				my $value = eval('$' . $param);
				
				my $field_type = $field_types->[$field];
			
#				$value = '<font color=red>DISABLED</font>' if !$value && $field_type == 3;
#				
				if ($field_type == 0) {
					$value = $value ? 'yes' : 'no';
				}
		
				$section .= qq{
	                 <tr>
	                   <td bgcolor="#dddddd" align=center valign=top width="50%"><font face="Verdana,Arial,Helvetica" size="1"><b>$param</b></font></td>
	                   <td bgcolor="#ffffff" align=center valign=top><font face="Verdana,Arial,Helvetica" size="1">$value</font></td>
	                 </tr>
				};
				
				$field++;
			}
			
			$section .= qq{</table>};
		}
		
		$section .= qq{
	                </td></tr></table></td>
	              </tr>
		};

		print $section;
	}
	
	print qq{
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
	};

	&get_footer;
	
	exit;
}

sub picker {
	return q{
<script language=javascript>
function getAnchorPosition(anchorname){var useWindow=false;var coordinates=new Object();var x=0,y=0;var use_gebi=false, use_css=false, use_layers=false;if(document.getElementById){use_gebi=true;}else if(document.all){use_css=true;}else if(document.layers){use_layers=true;}if(use_gebi && document.all){x=AnchorPosition_getPageOffsetLeft(document.all[anchorname]);y=AnchorPosition_getPageOffsetTop(document.all[anchorname]);}else if(use_gebi){var o=document.getElementById(anchorname);x=AnchorPosition_getPageOffsetLeft(o);y=AnchorPosition_getPageOffsetTop(o);}else if(use_css){x=AnchorPosition_getPageOffsetLeft(document.all[anchorname]);y=AnchorPosition_getPageOffsetTop(document.all[anchorname]);}else if(use_layers){var found=0;for(var i=0;i<document.anchors.length;i++){if(document.anchors[i].name==anchorname){found=1;break;}}if(found==0){coordinates.x=0;coordinates.y=0;return coordinates;}x=document.anchors[i].x;y=document.anchors[i].y;}else{coordinates.x=0;coordinates.y=0;return coordinates;}coordinates.x=x;coordinates.y=y;return coordinates;}
function getAnchorWindowPosition(anchorname){var coordinates=getAnchorPosition(anchorname);var x=0;var y=0;if(document.getElementById){if(isNaN(window.screenX)){x=coordinates.x-document.body.scrollLeft+window.screenLeft;y=coordinates.y-document.body.scrollTop+window.screenTop;}else{x=coordinates.x+window.screenX+(window.outerWidth-window.innerWidth)-window.pageXOffset;y=coordinates.y+window.screenY+(window.outerHeight-24-window.innerHeight)-window.pageYOffset;}}else if(document.all){x=coordinates.x-document.body.scrollLeft+window.screenLeft;y=coordinates.y-document.body.scrollTop+window.screenTop;}else if(document.layers){x=coordinates.x+window.screenX+(window.outerWidth-window.innerWidth)-window.pageXOffset;y=coordinates.y+window.screenY+(window.outerHeight-24-window.innerHeight)-window.pageYOffset;}coordinates.x=x;coordinates.y=y;return coordinates;}
function AnchorPosition_getPageOffsetLeft(el){var ol=el.offsetLeft;while((el=el.offsetParent) != null){ol += el.offsetLeft;}return ol;}
function AnchorPosition_getWindowOffsetLeft(el){return AnchorPosition_getPageOffsetLeft(el)-document.body.scrollLeft;}
function AnchorPosition_getPageOffsetTop(el){var ot=el.offsetTop;while((el=el.offsetParent) != null){ot += el.offsetTop;}return ot;}
function AnchorPosition_getWindowOffsetTop(el){return AnchorPosition_getPageOffsetTop(el)-document.body.scrollTop;}
function PopupWindow_getXYPosition(anchorname){var coordinates;if(this.type == "WINDOW"){coordinates = getAnchorWindowPosition(anchorname);}else{coordinates = getAnchorPosition(anchorname);}this.x = coordinates.x;this.y = coordinates.y;}
function PopupWindow_setSize(width,height){this.width = width;this.height = height;}
function PopupWindow_populate(contents){this.contents = contents;this.populated = false;}
function PopupWindow_setUrl(url){this.url = url;}
function PopupWindow_setWindowProperties(props){this.windowProperties = props;}
function PopupWindow_refresh(){if(this.divName != null){if(this.use_gebi){document.getElementById(this.divName).innerHTML = this.contents;}else if(this.use_css){document.all[this.divName].innerHTML = this.contents;}else if(this.use_layers){var d = document.layers[this.divName];d.document.open();d.document.writeln(this.contents);d.document.close();}}else{if(this.popupWindow != null && !this.popupWindow.closed){if(this.url!=""){this.popupWindow.location.href=this.url;}else{this.popupWindow.document.open();this.popupWindow.document.writeln(this.contents);this.popupWindow.document.close();}this.popupWindow.focus();}}}
function PopupWindow_showPopup(anchorname){this.getXYPosition(anchorname);this.x += this.offsetX;this.y += this.offsetY;if(!this.populated &&(this.contents != "")){this.populated = true;this.refresh();}if(this.divName != null){if(this.use_gebi){document.getElementById(this.divName).style.left = this.x + "px";document.getElementById(this.divName).style.top = this.y;document.getElementById(this.divName).style.visibility = "visible";}else if(this.use_css){document.all[this.divName].style.left = this.x;document.all[this.divName].style.top = this.y;document.all[this.divName].style.visibility = "visible";}else if(this.use_layers){document.layers[this.divName].left = this.x;document.layers[this.divName].top = this.y;document.layers[this.divName].visibility = "visible";}}else{if(this.popupWindow == null || this.popupWindow.closed){if(this.x<0){this.x=0;}if(this.y<0){this.y=0;}if(screen && screen.availHeight){if((this.y + this.height) > screen.availHeight){this.y = screen.availHeight - this.height;}}if(screen && screen.availWidth){if((this.x + this.width) > screen.availWidth){this.x = screen.availWidth - this.width;}}var avoidAboutBlank = window.opera ||( document.layers && !navigator.mimeTypes['*']) || navigator.vendor == 'KDE' ||( document.childNodes && !document.all && !navigator.taintEnabled);this.popupWindow = window.open(avoidAboutBlank?"":"about:blank","window_"+anchorname,this.windowProperties+",width="+this.width+",height="+this.height+",screenX="+this.x+",left="+this.x+",screenY="+this.y+",top="+this.y+"");}this.refresh();}}
function PopupWindow_hidePopup(){if(this.divName != null){if(this.use_gebi){document.getElementById(this.divName).style.visibility = "hidden";}else if(this.use_css){document.all[this.divName].style.visibility = "hidden";}else if(this.use_layers){document.layers[this.divName].visibility = "hidden";}}else{if(this.popupWindow && !this.popupWindow.closed){this.popupWindow.close();this.popupWindow = null;}}}
function PopupWindow_isClicked(e){if(this.divName != null){if(this.use_layers){var clickX = e.pageX;var clickY = e.pageY;var t = document.layers[this.divName];if((clickX > t.left) &&(clickX < t.left+t.clip.width) &&(clickY > t.top) &&(clickY < t.top+t.clip.height)){return true;}else{return false;}}else if(document.all){var t = window.event.srcElement;while(t.parentElement != null){if(t.id==this.divName){return true;}t = t.parentElement;}return false;}else if(this.use_gebi && e){var t = e.originalTarget;while(t.parentNode != null){if(t.id==this.divName){return true;}t = t.parentNode;}return false;}return false;}return false;}
function PopupWindow_hideIfNotClicked(e){if(this.autoHideEnabled && !this.isClicked(e)){this.hidePopup();}}
function PopupWindow_autoHide(){this.autoHideEnabled = true;}
function PopupWindow_hidePopupWindows(e){for(var i=0;i<popupWindowObjects.length;i++){if(popupWindowObjects[i] != null){var p = popupWindowObjects[i];p.hideIfNotClicked(e);}}}
function PopupWindow_attachListener(){if(document.layers){document.captureEvents(Event.MOUSEUP);}window.popupWindowOldEventListener = document.onmouseup;if(window.popupWindowOldEventListener != null){document.onmouseup = new Function("window.popupWindowOldEventListener();PopupWindow_hidePopupWindows();");}else{document.onmouseup = PopupWindow_hidePopupWindows;}}
function PopupWindow(){if(!window.popupWindowIndex){window.popupWindowIndex = 0;}if(!window.popupWindowObjects){window.popupWindowObjects = new Array();}if(!window.listenerAttached){window.listenerAttached = true;PopupWindow_attachListener();}this.index = popupWindowIndex++;popupWindowObjects[this.index] = this;this.divName = null;this.popupWindow = null;this.width=0;this.height=0;this.populated = false;this.visible = false;this.autoHideEnabled = false;this.contents = "";this.url="";this.windowProperties="toolbar=no,location=no,status=no,menubar=no,scrollbars=auto,resizable,alwaysRaised,dependent,titlebar=no";if(arguments.length>0){this.type="DIV";this.divName = arguments[0];}else{this.type="WINDOW";}this.use_gebi = false;this.use_css = false;this.use_layers = false;if(document.getElementById){this.use_gebi = true;}else if(document.all){this.use_css = true;}else if(document.layers){this.use_layers = true;}else{this.type = "WINDOW";}this.offsetX = 0;this.offsetY = 0;this.getXYPosition = PopupWindow_getXYPosition;this.populate = PopupWindow_populate;this.setUrl = PopupWindow_setUrl;this.setWindowProperties = PopupWindow_setWindowProperties;this.refresh = PopupWindow_refresh;this.showPopup = PopupWindow_showPopup;this.hidePopup = PopupWindow_hidePopup;this.setSize = PopupWindow_setSize;this.isClicked = PopupWindow_isClicked;this.autoHide = PopupWindow_autoHide;this.hideIfNotClicked = PopupWindow_hideIfNotClicked;}
ColorPicker_targetInput = null;
function ColorPicker_writeDiv(){document.writeln("<DIV ID=\"colorPickerDiv\" STYLE=\"position:absolute;visibility:hidden;\"> </DIV>");}
function ColorPicker_show(anchorname){this.showPopup(anchorname);}
function ColorPicker_pickColor(color,obj){obj.hidePopup();pickColor(color);}
function pickColor(color){if(ColorPicker_targetInput==null){alert("Target Input is null, which means you either didn't use the 'select' function or you have no defined your own 'pickColor' function to handle the picked color!");return;}ColorPicker_targetInput.value = color;}
function ColorPicker_select(inputobj,linkname){if(inputobj.type!="text" && inputobj.type!="hidden" && inputobj.type!="textarea"){alert("colorpicker.select: Input object passed is not a valid form input object");window.ColorPicker_targetInput=null;return;}window.ColorPicker_targetInput = inputobj;this.show(linkname);}
function ColorPicker_highlightColor(c){var thedoc =(arguments.length>1)?arguments[1]:window.document;var d = thedoc.getElementById("colorPickerSelectedColor");d.style.backgroundColor = c;d = thedoc.getElementById("colorPickerSelectedColorValue");d.innerHTML = c;}
function ColorPicker(){var windowMode = false;if(arguments.length==0){var divname = "colorPickerDiv";}else if(arguments[0] == "window"){var divname = '';windowMode = true;}else{var divname = arguments[0];}if(divname != ""){var cp = new PopupWindow(divname);}else{var cp = new PopupWindow();cp.setSize(225,250);}cp.currentValue = "#FFFFFF";cp.writeDiv = ColorPicker_writeDiv;cp.highlightColor = ColorPicker_highlightColor;cp.show = ColorPicker_show;cp.select = ColorPicker_select;var colors = new Array("#000000","#000033","#000066","#000099","#0000CC","#0000FF","#330000","#330033","#330066","#330099","#3300CC",
"#3300FF","#660000","#660033","#660066","#660099","#6600CC","#6600FF","#990000","#990033","#990066","#990099",
"#9900CC","#9900FF","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#FF0000","#FF0033","#FF0066",
"#FF0099","#FF00CC","#FF00FF","#003300","#003333","#003366","#003399","#0033CC","#0033FF","#333300","#333333",
"#333366","#333399","#3333CC","#3333FF","#663300","#663333","#663366","#663399","#6633CC","#6633FF","#993300",
"#993333","#993366","#993399","#9933CC","#9933FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF",
"#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#006600","#006633","#006666","#006699","#0066CC",
"#0066FF","#336600","#336633","#336666","#336699","#3366CC","#3366FF","#666600","#666633","#666666","#666699",
"#6666CC","#6666FF","#996600","#996633","#996666","#996699","#9966CC","#9966FF","#CC6600","#CC6633","#CC6666",
"#CC6699","#CC66CC","#CC66FF","#FF6600","#FF6633","#FF6666","#FF6699","#FF66CC","#FF66FF","#009900","#009933",
"#009966","#009999","#0099CC","#0099FF","#339900","#339933","#339966","#339999","#3399CC","#3399FF","#669900",
"#669933","#669966","#669999","#6699CC","#6699FF","#999900","#999933","#999966","#999999","#9999CC","#9999FF",
"#CC9900","#CC9933","#CC9966","#CC9999","#CC99CC","#CC99FF","#FF9900","#FF9933","#FF9966","#FF9999","#FF99CC",
"#FF99FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#33CC00","#33CC33","#33CC66","#33CC99",
"#33CCCC","#33CCFF","#66CC00","#66CC33","#66CC66","#66CC99","#66CCCC","#66CCFF","#99CC00","#99CC33","#99CC66",
"#99CC99","#99CCCC","#99CCFF","#CCCC00","#CCCC33","#CCCC66","#CCCC99","#CCCCCC","#CCCCFF","#FFCC00","#FFCC33",
"#FFCC66","#FFCC99","#FFCCCC","#FFCCFF","#00FF00","#00FF33","#00FF66","#00FF99","#00FFCC","#00FFFF","#33FF00",
"#33FF33","#33FF66","#33FF99","#33FFCC","#33FFFF","#66FF00","#66FF33","#66FF66","#66FF99","#66FFCC","#66FFFF",
"#99FF00","#99FF33","#99FF66","#99FF99","#99FFCC","#99FFFF","#CCFF00","#CCFF33","#CCFF66","#CCFF99","#CCFFCC",
"#CCFFFF","#FFFF00","#FFFF33","#FFFF66","#FFFF99","#FFFFCC","#FFFFFF");var total = colors.length;var width = 18;var cp_contents = "";var windowRef =(windowMode)?"window.opener.":"";if(windowMode){cp_contents += "<HTML><HEAD><TITLE>Select Color</TITLE></HEAD>";cp_contents += "<BODY MARGINWIDTH=0 MARGINHEIGHT=0 LEFTMARGIN=0 TOPMARGIN=0><CENTER>";}cp_contents += "<TABLE BORDER=1 CELLSPACING=1 CELLPADDING=0>";var use_highlight =(document.getElementById || document.all)?true:false;for(var i=0;i<total;i++){if((i % width) == 0){cp_contents += "<TR>";}if(use_highlight){var mo = 'onMouseOver="'+windowRef+'ColorPicker_highlightColor(\''+colors[i]+'\',window.document)"';}else{mo = "";}cp_contents += '<TD BGCOLOR="'+colors[i]+'"><FONT SIZE="-3"><A HREF="#" onClick="'+windowRef+'ColorPicker_pickColor(\''+colors[i]+'\','+windowRef+'window.popupWindowObjects['+cp.index+']);return false;" '+mo+' STYLE="text-decoration:none;">&nbsp;&nbsp;&nbsp;</A></FONT></TD>';if( ((i+1)>=total) ||(((i+1) % width) == 0)){cp_contents += "</TR>";}}if(document.getElementById){var width1 = Math.floor(width/2);var width2 = width = width1;cp_contents += "<TR><TD COLSPAN='"+width1+"' BGCOLOR='#ffffff' ID='colorPickerSelectedColor'>&nbsp;</TD><TD COLSPAN='"+width2+"' ALIGN='CENTER' ID='colorPickerSelectedColorValue'>#FFFFFF</TD></TR>";}cp_contents += "</TABLE>";if(windowMode){cp_contents += "</CENTER></BODY></HTML>";}cp.populate(cp_contents+"\n");cp.offsetY = 25;cp.autoHide();return cp;}
var cp = new ColorPicker('window'); // Popup window
</script>
	};
}

1;
